#
# Jing-Doo Wang
# jdwang@asia.edu.tw
# 2020.6.8
#

import requests
from bs4 import BeautifulSoup
import csv
import re
import pymysql

db = pymysql.connect("localhost", "root", "jdwang123", "AU_Faculty", charset="utf8")      
cursor = db.cursor()  # 建立cursor物件

#Table = "Faculty_1"
#Table = "Faculty_2"
Table = "Faculty_3"

FieldNamesInOrder = "(C_Name, E_Name, Office, Department, Faculty_Rank, Graguate, Degree, Building, Ext, E_mail)"

Department = '資訊工程'
#url = "https://csie.asia.edu.tw/faculty/professors"
#Faculty_Rank = '教授'
#url = "https://csie.asia.edu.tw/faculty/associate-professors"
#Faculty_Rank = '副教授'
url = "https://csie.asia.edu.tw/faculty/assistant-professors"
Faculty_Rank = '助理教授'

OneRecordDict = {"中文姓名":"","英文姓名":"",'Department':'','Faculty_Rank':'',"學歷":"","Degree":"","Building":'',"辦公室":"","分機":"","E-mail":""} 

# 開啟CSV檔案寫入截取的資料
#csvfile = "AU_CSIE_ALLFaculty_jdwang2020_6_8.csv"

r = requests.get(url)
r.encoding = "utf8"
soup = BeautifulSoup(r.text, "lxml")
#print (soup.text)
tag_table = soup.find(attrs={"class":"row contact-category"})  # 找到<table>
#print (tag_table.prettify())
# <div class="col-sm-12">
ALL_Professors = tag_table.find_all("div",class_="col-sm-12")
#print(ALL_Professors[0])
#
# Parse each of Faculties
#
for One in ALL_Professors:
        for onekey in OneRecordDict.keys():
            OneRecordDict[onekey] = ''
        
        OneRecordDict['Department'] = Department
        OneRecordDict['Faculty_Rank'] = Faculty_Rank
        #
        # Parse Chinese name and English name of one faculty
        #
        NameInfStr = One.find('h2','card-header').text
        #print(NameInfStr)
        ''' #蔡進發 （Jeffrey J.P. Tsai） or 陳良弼(Arbee L.P. Chen)'''
        NameInfo = re.split(r'[(（]',NameInfStr)
       
        if (len(NameInfo) == 2):
           OneRecordDict["中文姓名"] = NameInfo[0].replace(' ','')
           OneRecordDict["英文姓名"] = NameInfo[1].replace(')','').replace('）','')
        else:
           OneRecordDict["中文姓名"] = ''      
           OneRecordDict["英文姓名"] = NameInfo[0].replace(' ','')
        #
        # Parse the other information of one faculty
        #
        ALL_card_description = One.find_all("p",class_="card-description")       
        for oneItem in ALL_card_description:
            #
            # a Record of one Faculty
            #
            OneRecordDict[oneItem.text.split('：')[0].replace("\n","")] = oneItem.text.split('：')[1].replace("\t","").replace(" ","")   
        
            if (oneItem.text.split('：')[0].replace("\n","") ==  '學歷'):
                #print(oneItem.text.split('：')[0].replace("\n",""))
                Degree = oneItem.text.split('：')[1].replace("\t","").replace(" ","")
                #print (Degree)
                #https://www.afternerd.com/blog/python-string-contains/
                if (Degree.find("博士") != -1):
                   OneRecordDict["Degree"] = "博士"
                #https://www.footmark.info/programming-language/python/python-if-elif-else/
                elif (Degree.find("碩士")  != -1):
                    OneRecordDict["Degree"] = "碩士"
            #辦公室： 資訊大樓六樓I626R
            if (oneItem.text.split('：')[0].replace("\n","") ==  '辦公室'):
                #print(oneItem.text.split('：')[0].replace("\n","")) 
                Location = oneItem.text.split('：')[1].replace("\t","").replace(" ","")
                #print(Location)
                if (Location.find('大樓') != -1):
                    ##辦公室： 資訊大樓六樓I626R
                    BuildName = Location[:Location.find('大樓')]
                    OneRecordDict["Building"] = BuildName+'大樓'
                    OneRecordDict['辦公室'] = Location[Location.rfind('樓')+1:]
                else:
                    #辦公室： 8025 '辦公室': 'I624' '辦公室': 'H602'
                    OneRecordDict['辦公室'] = Location
                    if (Location.find('I') != -1):
                        OneRecordDict["Building"] = '資訊大樓'
                    elif (Location.find('H')!= -1):
                        OneRecordDict["Building"] = '健康大樓'
                    elif (Location.find('M')!= -1):
                        OneRecordDict["Building"] = '管理大樓'
                    else:
                        OneRecordDict["Building"] = ''
              
        # 建立SQL指令INSERT字串 
        sql = "INSERT INTO "+Table +" "+ FieldNamesInOrder +" VALUES ('{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}')"
        sql = sql.format(OneRecordDict['中文姓名'],
                         OneRecordDict['英文姓名'],
                         OneRecordDict['辦公室'],
                         OneRecordDict['Department'],
                         OneRecordDict['Faculty_Rank'],
                         OneRecordDict['學歷'],
                         OneRecordDict['Degree'],
                         OneRecordDict['Building'],
                         OneRecordDict['分機'],
                         OneRecordDict['E-mail'])
        print(sql)
        try:
            cursor.execute(sql)   # 執行SQL指令
            db.commit() # 確認交易
            print("新增一筆記錄...")
        except:
            db.rollback() # 回復交易 
            print("新增記錄失敗...")

db.close()  # 關閉資料庫連接

       

