#
# Jing-Doo Wang
# jdwang@asia.edu.tw
# 2020.6.8
#

import requests
from bs4 import BeautifulSoup
import csv
import re

url = "https://csie.asia.edu.tw/faculty/professors"

r = requests.get(url)
r.encoding = "utf8"
soup = BeautifulSoup(r.text, "lxml")
#print (soup.text)
tag_table = soup.find(attrs={"class":"row contact-category"})  # 找到<table>
#print (tag_table.prettify())
# <div class="col-sm-12">
ALL_Professors = tag_table.find_all("div",class_="col-sm-12")
#print(ALL_Professors[0])

# 開啟CSV檔案寫入截取的資料
csvfile = "AU_CSIE_Professor_jdwang2020_6_8_BIG5_FieldName_Dictionary_PresentTsay.csv"

# 
# AsiaUniversity_CSIE_Prof_jdwang2020_6_5.sql
#

# 建立SQL指令INSERT字串

#with open(csvfile, 'w+', newline='', encoding="utf-8") as fp:
with open(csvfile, 'w+', newline='', encoding="big5") as fp:
    writer = csv.writer(fp)
    
    OneRecordDict = {"中文姓名":"","英文姓名":"",'Department':'','Faculty_Rank':'',"學歷":"","Degree":"","Building":'',"辦公室":"","分機":"","E-mail":""}   
    #
    # 產生 英文欄位名稱
    #
    OneRecordDict_Map = {"中文姓名":"C_Name","英文姓名":"E_Name",'Department':'Department','Faculty_Rank':'Faculty_Rank',"學歷":"Graduate","Degree":"Degree","Building":'Building',"辦公室":"Office","分機":"Ext","E-mail":"E-mail"}           
    for onefield in OneRecordDict.keys():
            fp.write(OneRecordDict_Map[onefield]+',')
    fp.write('\n')
    #for row in rows:
    for One in ALL_Professors:
        
        OneRecordDict = {"中文姓名":"","英文姓名":"",'Department':'','Faculty_Rank':'',"學歷":"","Degree":"","Building":'',"辦公室":"","分機":"","E-mail":""}                      
        OneRecordDict['Department'] = '資訊工程'
        OneRecordDict['Faculty_Rank'] = '教授'
        
        NameInfStr = One.find('h2','card-header').text
        #print(NameInfStr)
        NameInfo = re.split(r'[(（]',NameInfStr)
        Name_Chinese = ''
        Name_English = ''
        if (len(NameInfo) == 2):
           Name_Chinese = NameInfo[0].replace(' ','')
           Name_English = NameInfo[1].replace(')','').replace('）','')
        else:
           Name_English = NameInfo[0].replace(' ','')
        #print (Name_Chinese, Name_English)     
        OneRecordDict["中文姓名"] = Name_Chinese
        OneRecordDict["英文姓名"] = Name_English
        #OneRecordList.append(One.find('h2','card-header').string)
       
        ALL_card_description = One.find_all("p",class_="card-description")     
        for oneItem in ALL_card_description:
            OneRecordDict[oneItem.text.split('：')[0].replace("\n","")] = oneItem.text.split('：')[1].replace("\t","").replace(" ","")   
        
            if (oneItem.text.split('：')[0].replace("\n","") ==  '學歷'):
                #print(oneItem.text.split('：')[0].replace("\n",""))
                Degree = oneItem.text.split('：')[1].replace("\t","").replace(" ","")
                #print (Degree)
                #https://www.afternerd.com/blog/python-string-contains/
                if (Degree.find("博士") != -1):
                   OneRecordDict["Degree"] = "博士"
                #https://www.footmark.info/programming-language/python/python-if-elif-else/
                elif (Degree.find("碩士")  != -1):
                    OneRecordDict["Degree"] = "碩士"
            #辦公室： 資訊大樓六樓I626R
            if (oneItem.text.split('：')[0].replace("\n","") ==  '辦公室'):
                #print(oneItem.text.split('：')[0].replace("\n","")) 
                Location = oneItem.text.split('：')[1].replace("\t","").replace(" ","")
                #print(Location)
                if (Location.find('大樓') != -1):
                    ##辦公室： 資訊大樓六樓I626R
                    BuildName = Location[:Location.find('大樓')]
                    OneRecordDict["Building"] = BuildName+'大樓'
                    OneRecordDict['辦公室'] = Location[Location.rfind('樓')+1:]
                else:
                    #辦公室： 8025 '辦公室': 'I624' '辦公室': 'H602'
                    OneRecordDict['辦公室'] = Location
                    if (Location.find('I') != -1):
                        OneRecordDict["Building"] = '資訊大樓'
                    elif (Location.find('H')!= -1):
                        OneRecordDict["Building"] = '健康大樓'
                    elif (Location.find('M')!= -1):
                        OneRecordDict["Building"] = '管理大樓'
                    else:
                        OneRecordDict["Building"] = ''
        #print(OneRecordList)
        for onefield in OneRecordDict.keys():           
            #print (onefield, OneRecordDict[onefield])
            fp.write(OneRecordDict[onefield]+',')     
        fp.write('\n')
        
        
        #Ch10_5b.py
        import pymysql
        # 建立資料庫連接
        db = pymysql.connect("localhost", "root", "jdwang123", "AU_Faculty", charset="utf8")      
        cursor = db.cursor()  # 建立cursor物件
        # 建立SQL指令INSERT字串
       
        sql = """INSERT INTO Faculty_2 (C_Name, E_Name, Office, Department, Faculty_Rank, Graguate,Degree,Building,Ext,E_mail)
                 VALUES ('{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}')"""
        sql = sql.format(OneRecordDict['中文姓名'],
                         OneRecordDict['英文姓名'],
                         OneRecordDict['辦公室'],
                         OneRecordDict['Department'],
                         OneRecordDict['Faculty_Rank'],
                         OneRecordDict['學歷'],
                         OneRecordDict['Degree'],
                         OneRecordDict['Building'],
                         OneRecordDict['分機'],
                         OneRecordDict['E-mail'])
        print(sql)
        try:
            cursor.execute(sql)   # 執行SQL指令
            db.commit() # 確認交易
            print("新增一筆記錄...")
        except:
            db.rollback() # 回復交易 
            print("新增記錄失敗...")
        db.close()  # 關閉資料庫連接

       

